Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/iostart.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/iostart.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/iostart.F90	(revision 3605)
@@ -25,5 +25,5 @@
 
     PUBLIC get_field,get_var,put_field,put_var
-    PUBLIC Open_startphy,close_startphy,open_restartphy,close_restartphy
+    PUBLIC Open_startphy,close_startphy,open_restartphy,close_restartphy, enddef_restartphy
     
 CONTAINS
@@ -117,4 +117,5 @@
   USE netcdf
   USE dimphy
+  USE geometry_mod
   USE mod_grid_phy_lmdz
   USE mod_phys_lmdz_para
@@ -125,15 +126,28 @@
     LOGICAL,OPTIONAL :: found
     
-    REAL    :: field_glo(klon_glo,field_size)
+    REAL,ALLOCATABLE    :: field_glo(:,:)
+    REAL,ALLOCATABLE    :: field_glo_tmp(:,:)
+    INTEGER,ALLOCATABLE :: ind_cell_glo_glo(:)
     LOGICAL :: tmp_found
     INTEGER :: varid
-    INTEGER :: ierr
-    
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    INTEGER :: ierr,i
+
+    IF (is_master) THEN 
+      ALLOCATE(ind_cell_glo_glo(klon_glo))
+      ALLOCATE(field_glo(klon_glo,field_size))
+      ALLOCATE(field_glo_tmp(klon_glo,field_size))
+    ELSE
+      ALLOCATE(ind_cell_glo_glo(0))
+      ALLOCATE(field_glo(0,0))
+    ENDIF
+    
+    CALL gather(ind_cell_glo,ind_cell_glo_glo)
+    
+    IF (is_master) THEN
   
       ierr=NF90_INQ_VARID(nid_start,Field_name,varid)
       
       IF (ierr==NF90_NOERR) THEN
-        CALL body(field_glo)
+        CALL body(field_glo_tmp)
         tmp_found=.TRUE.
       ELSE
@@ -146,4 +160,9 @@
 
     IF (tmp_found) THEN
+      IF (is_master) THEN  
+        DO i=1,klon_glo
+         field_glo(i,:)=field_glo_tmp(ind_cell_glo_glo(i),:)
+        ENDDO
+      ENDIF
       CALL scatter(field_glo,field)
     ENDIF
@@ -307,9 +326,19 @@
       ierr = NF90_DEF_DIM (nid_restart, "horizon_klevp1", klon_glo*klevp1, idim4)
 
-      ierr = NF90_ENDDEF(nid_restart)
+!      ierr = NF90_ENDDEF(nid_restart)
     ENDIF
 
   END SUBROUTINE open_restartphy
   
+  SUBROUTINE enddef_restartphy
+  USE netcdf
+  USE mod_phys_lmdz_para
+  IMPLICIT NONE
+    INTEGER          :: ierr
+
+    IF (is_master) ierr = NF90_ENDDEF(nid_restart)
+ 
+  END SUBROUTINE enddef_restartphy
+
   SUBROUTINE close_restartphy
   USE netcdf
@@ -318,47 +347,49 @@
     INTEGER          :: ierr
 
-    IF (is_mpi_root .AND. is_omp_root) THEN
-      ierr = NF90_CLOSE (nid_restart)
-    ENDIF
+    IF (is_master) ierr = NF90_CLOSE (nid_restart)
  
   END SUBROUTINE close_restartphy
 
   
-  SUBROUTINE put_field_r1(field_name,title,field)
-  IMPLICIT NONE
+  SUBROUTINE put_field_r1(pass, field_name,title,field)
+  IMPLICIT NONE
+  INTEGER, INTENT(IN)            :: pass
   CHARACTER(LEN=*),INTENT(IN)    :: field_name
   CHARACTER(LEN=*),INTENT(IN)    :: title
   REAL,INTENT(IN)                :: field(:)
-  
-    CALL put_field_rgen(field_name,title,field,1)
+    CALL put_field_rgen(pass, field_name,title,field,1)
   
   END SUBROUTINE put_field_r1
 
-  SUBROUTINE put_field_r2(field_name,title,field)
-  IMPLICIT NONE
+  SUBROUTINE put_field_r2(pass, field_name,title,field)
+  IMPLICIT NONE
+  INTEGER, INTENT(IN)            :: pass
   CHARACTER(LEN=*),INTENT(IN)    :: field_name
   CHARACTER(LEN=*),INTENT(IN)    :: title
   REAL,INTENT(IN)                :: field(:,:)
   
-    CALL put_field_rgen(field_name,title,field,size(field,2))
+    CALL put_field_rgen(pass, field_name,title,field,size(field,2))
   
   END SUBROUTINE put_field_r2
 
-  SUBROUTINE put_field_r3(field_name,title,field)
-  IMPLICIT NONE
+  SUBROUTINE put_field_r3(pass, field_name,title,field)
+  IMPLICIT NONE
+  INTEGER, INTENT(IN)            :: pass
   CHARACTER(LEN=*),INTENT(IN)    :: field_name
   CHARACTER(LEN=*),INTENT(IN)    :: title
   REAL,INTENT(IN)                :: field(:,:,:)
   
-    CALL put_field_rgen(field_name,title,field,size(field,2)*size(field,3))
+    CALL put_field_rgen(pass, field_name,title,field,size(field,2)*size(field,3))
   
   END SUBROUTINE put_field_r3
   
-  SUBROUTINE put_field_rgen(field_name,title,field,field_size)
+  SUBROUTINE put_field_rgen(pass, field_name,title,field,field_size)
   USE netcdf
   USE dimphy
+  USE geometry_mod
   USE mod_grid_phy_lmdz
   USE mod_phys_lmdz_para
   IMPLICIT NONE
+  INTEGER, INTENT(IN)            :: pass
   CHARACTER(LEN=*),INTENT(IN)    :: field_name
   CHARACTER(LEN=*),INTENT(IN)    :: title
@@ -366,13 +397,18 @@
   REAL,INTENT(IN)                :: field(klon,field_size)
   
-  REAL                           :: field_glo(klon_glo,field_size)
-  INTEGER                        :: ierr
+!  REAL                           :: field_glo(klon_glo,field_size)
+!  REAL                           :: field_glo_tmp(klon_glo,field_size)
+  REAL ,ALLOCATABLE              :: field_glo(:,:)
+  REAL ,ALLOCATABLE              :: field_glo_tmp(:,:)
+  INTEGER,ALLOCATABLE            :: ind_cell_glo_glo(:)
+!  INTEGER                        :: ind_cell_glo_glo(klon_glo)
+  INTEGER                        :: ierr,i
   INTEGER                        :: nvarid
   INTEGER                        :: idim
    
-   
-    CALL gather(field,field_glo)
-    
-    IF (is_mpi_root .AND. is_omp_root) THEN
+! first pass : definition   
+  IF (pass==1) THEN
+    
+    IF (is_master) THEN
 
       IF (field_size==1) THEN
@@ -387,5 +423,5 @@
       ENDIF
          
-      ierr = NF90_REDEF (nid_restart)
+!      ierr = NF90_REDEF (nid_restart)
 #ifdef NC_DOUBLE
       ierr = NF90_DEF_VAR (nid_restart, field_name, NF90_DOUBLE,(/ idim /),nvarid)
@@ -394,12 +430,40 @@
 #endif
       IF (LEN_TRIM(title) > 0) ierr = NF90_PUT_ATT (nid_restart,nvarid,"title", title)
-      ierr = NF90_ENDDEF(nid_restart)
-      ierr = NF90_PUT_VAR(nid_restart,nvarid,RESHAPE(field_glo,(/klon_glo*field_size/)))
-    ENDIF
-    
-   END SUBROUTINE put_field_rgen  
-  
-   SUBROUTINE put_var_r0(var_name,title,var)
+!      ierr = NF90_ENDDEF(nid_restart)
+     ENDIF
+
+! second pass : write     
+   ELSE IF (pass==2) THEN 
+    
+     IF (is_master) THEN
+       ALLOCATE(ind_cell_glo_glo(klon_glo))
+       ALLOCATE(field_glo(klon_glo,field_size))
+       ALLOCATE(field_glo_tmp(klon_glo,field_size))
+     ELSE
+       ALLOCATE(ind_cell_glo_glo(0))
+       ALLOCATE(field_glo_tmp(0,0))
+     ENDIF
+     
+     CALL gather(ind_cell_glo,ind_cell_glo_glo) 
+
+     CALL gather(field,field_glo_tmp)
+    
+     IF (is_master) THEN
+
+       DO i=1,klon_glo
+         field_glo(ind_cell_glo_glo(i),:)=field_glo_tmp(i,:)
+       ENDDO
+
+       ierr = NF90_INQ_VARID(nid_restart, field_name, nvarid)
+       ierr = NF90_PUT_VAR(nid_restart,nvarid,RESHAPE(field_glo,(/klon_glo*field_size/)))
+      ENDIF
+   ENDIF
+    
+ END SUBROUTINE put_field_rgen  
+  
+
+ SUBROUTINE put_var_r0(pass, var_name,title,var)
    IMPLICIT NONE
+     INTEGER, INTENT(IN)            :: pass
      CHARACTER(LEN=*),INTENT(IN) :: var_name
      CHARACTER(LEN=*),INTENT(IN) :: title
@@ -409,53 +473,57 @@
      varin(1)=var
      
-     CALL put_var_rgen(var_name,title,varin,size(varin))
+     CALL put_var_rgen(pass, var_name,title,varin,size(varin))
 
   END SUBROUTINE put_var_r0
 
 
-   SUBROUTINE put_var_r1(var_name,title,var)
+   SUBROUTINE put_var_r1(pass, var_name,title,var)
    IMPLICIT NONE
+     INTEGER, INTENT(IN)            :: pass
      CHARACTER(LEN=*),INTENT(IN) :: var_name
      CHARACTER(LEN=*),INTENT(IN) :: title
      REAL,INTENT(IN)             :: var(:)
      
-     CALL put_var_rgen(var_name,title,var,size(var))
+     CALL put_var_rgen(pass, var_name,title,var,size(var))
 
   END SUBROUTINE put_var_r1
  
-  SUBROUTINE put_var_r2(var_name,title,var)
+  SUBROUTINE put_var_r2(pass, var_name,title,var)
    IMPLICIT NONE
+     INTEGER, INTENT(IN)            :: pass
      CHARACTER(LEN=*),INTENT(IN) :: var_name
      CHARACTER(LEN=*),INTENT(IN) :: title
      REAL,INTENT(IN)             :: var(:,:)
      
-     CALL put_var_rgen(var_name,title,var,size(var))
+     CALL put_var_rgen(pass, var_name,title,var,size(var))
 
   END SUBROUTINE put_var_r2     
   
-  SUBROUTINE put_var_r3(var_name,title,var)
+  SUBROUTINE put_var_r3(pass, var_name,title,var)
    IMPLICIT NONE
+     INTEGER, INTENT(IN)            :: pass
      CHARACTER(LEN=*),INTENT(IN) :: var_name
      CHARACTER(LEN=*),INTENT(IN) :: title
      REAL,INTENT(IN)             :: var(:,:,:)
      
-     CALL put_var_rgen(var_name,title,var,size(var))
+     CALL put_var_rgen(pass, var_name,title,var,size(var))
 
   END SUBROUTINE put_var_r3
 
-  SUBROUTINE put_var_rgen(var_name,title,var,var_size)
+  SUBROUTINE put_var_rgen(pass, var_name,title,var,var_size)
   USE netcdf
   USE dimphy
   USE mod_phys_lmdz_para
   IMPLICIT NONE
-     CHARACTER(LEN=*),INTENT(IN) :: var_name
-     CHARACTER(LEN=*),INTENT(IN) :: title
-     INTEGER,INTENT(IN)          :: var_size
-     REAL,INTENT(IN)             :: var(var_size)
-     
-     INTEGER :: ierr
-     INTEGER :: nvarid
+    INTEGER, INTENT(IN)         :: pass
+    CHARACTER(LEN=*),INTENT(IN) :: var_name
+    CHARACTER(LEN=*),INTENT(IN) :: title
+    INTEGER,INTENT(IN)          :: var_size
+    REAL,INTENT(IN)             :: var(var_size)
+    
+    INTEGER :: ierr
+    INTEGER :: nvarid
          
-    IF (is_mpi_root .AND. is_omp_root) THEN
+    IF (is_master) THEN
 
       IF (var_size/=length) THEN
@@ -463,17 +531,23 @@
         call abort_physic("", "", 1)
       ENDIF
-      
-      ierr = NF90_REDEF (nid_restart)
+
+     ! first pass : definition   
+      IF (pass==1) THEN
+        
+!      ierr = NF90_REDEF (nid_restart)
 
 #ifdef NC_DOUBLE
-      ierr = NF90_DEF_VAR (nid_restart, var_name, NF90_DOUBLE,(/ idim1 /),nvarid)
+        ierr = NF90_DEF_VAR (nid_restart, var_name, NF90_DOUBLE,(/ idim1 /),nvarid)
 #else
-      ierr = NF90_DEF_VAR (nid_restart, var_name, NF90_FLOAT,(/ idim1 /),nvarid)
+        ierr = NF90_DEF_VAR (nid_restart, var_name, NF90_FLOAT,(/ idim1 /),nvarid)
 #endif
-      IF (LEN_TRIM(title)>0) ierr = NF90_PUT_ATT (nid_restart,nvarid,"title", title)
-      ierr = NF90_ENDDEF(nid_restart)
-     
-      ierr = NF90_PUT_VAR(nid_restart,nvarid,var)
-
+        IF (LEN_TRIM(title)>0) ierr = NF90_PUT_ATT (nid_restart,nvarid,"title", title)
+!      ierr = NF90_ENDDEF(nid_restart)
+
+    ! second pass : write     
+      ELSE IF (pass==2) THEN 
+        ierr = NF90_INQ_VARID(nid_restart, var_name, nvarid)
+        ierr = NF90_PUT_VAR(nid_restart,nvarid,var)
+      ENDIF
     ENDIF
     
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/limit_read_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/limit_read_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/limit_read_mod.F90	(revision 3605)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 MODULE limit_read_mod
@@ -31,4 +31,26 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
+
+  SUBROUTINE init_limit_read(first_day)
+  USE mod_grid_phy_lmdz
+  USE surface_data
+  USE mod_phys_lmdz_para
+#ifdef CPP_XIOS
+  USE XIOS
+#endif
+  IMPLICIT NONE
+    INTEGER, INTENT(IN) :: first_day
+    
+    
+    IF ( type_ocean /= 'couple') THEN
+      IF (grid_type==unstructured) THEN
+#ifdef CPP_XIOS
+        IF (is_omp_master) CALL xios_set_file_attr("limit_read",enabled=.TRUE.,record_offset=first_day)
+#endif
+      ENDIF  
+    ENDIF
+
+  END SUBROUTINE init_limit_read
+  
   SUBROUTINE limit_read_frac(itime, dtime, jour, pctsrf_new, is_modified)
 !
@@ -150,5 +172,8 @@
     USE phys_cal_mod, ONLY : calend, year_len
     USE print_control_mod, ONLY: lunout, prt_level
-
+#ifdef CPP_XIOS
+    USE XIOS, ONLY: xios_recv_field
+#endif
+    
     IMPLICIT NONE
     
@@ -179,4 +204,10 @@
     REAL, DIMENSION(klon_glo)                 :: rug_glo  ! rugosity at global grid
     REAL, DIMENSION(klon_glo)                 :: alb_glo  ! albedo at global grid
+
+    REAL, DIMENSION(klon_mpi,nbsrf)           :: pct_mpi  ! fraction at global grid
+    REAL, DIMENSION(klon_mpi)                 :: sst_mpi  ! sea-surface temperature at global grid
+    REAL, DIMENSION(klon_mpi)                 :: rug_mpi  ! rugosity at global grid
+    REAL, DIMENSION(klon_mpi)                 :: alb_mpi  ! albedo at global grid
+
     CHARACTER(len=20)                         :: modname='limit_read_mod'     
     CHARACTER(LEN=99)                         :: abort_message, calendar, str
@@ -220,13 +251,21 @@
           END IF
 
-          !--- ERROR IF FILE RECORDS NUMBER IS NOT EQUAL TO EXPECTED NUMBER OF DAYS
-          ierr=NF90_INQUIRE(nid, UnlimitedDimID=ndimid)
+          !--- ERROR IF FILE RECORDS NUMBER IS NOT EQUAL TO EXPECTED NUMBER OF DAYS          
+          IF (grid_type==unstructured) THEN
+            ierr=NF90_INQ_DIMID(nid,"time_year",ndimid)
+          ELSE
+            ierr=NF90_INQUIRE(nid, UnlimitedDimID=ndimid)
+          ENDIF
           ierr=NF90_INQUIRE_DIMENSION(nid, ndimid, len=nn)
-          WRITE(abort_message,'(a,2(i3,a))')'limit.nc records number (',nn,') does no'//&
+          WRITE(abort_message,'(a,2(i0,a))')'limit.nc records number (',nn,') does no'//&
             't match year length (',year_len,')'
           IF(nn/=year_len) CALL abort_physic(modname,abort_message,1)
 
           !--- ERROR IF FILES AND LMDZ HORIZONTAL RESOLUTIONS DO NOT MATCH
-          ierr=NF90_INQ_DIMID(nid, 'points_physiques', ndimid)
+          IF (grid_type==unstructured) THEN
+            ierr=NF90_INQ_DIMID(nid, 'cell', ndimid)
+          ELSE
+            ierr=NF90_INQ_DIMID(nid, 'points_physiques', ndimid)
+          ENDIF
           ierr=NF90_INQUIRE_DIMENSION(nid, ndimid, len=nn)
           WRITE(abort_message,'(a,2(i0,a))')'limit.nc horizontal number of cells (',nn, &
@@ -249,9 +288,54 @@
 
     is_modified = .FALSE.
-    IF (MOD(itime-1, lmt_pas) == 0 .OR. jour_lu /= jour ) THEN   ! time to read
+!ym    IF (MOD(itime-1, lmt_pas) == 0 .OR. jour_lu /= jour ) THEN   ! time to read
+!  not REALLY PERIODIC
+    IF (MOD(itime-1, lmt_pas) == 0 .OR. (jour_lu /= jour .AND. grid_type /= unstructured)) THEN   ! time to read
+!    IF (MOD(itime-1, lmt_pas) == 0) THEN   ! time to read
        jour_lu = jour
        is_modified = .TRUE.
+
+      IF (grid_type==unstructured) THEN
+
+#ifdef CPP_XIOS
+        IF ( type_ocean /= 'couple') THEN
+
+           IF (is_omp_master) CALL xios_recv_field("foce_limin",pct_mpi(:,is_oce))
+           IF (is_omp_master) CALL xios_recv_field("fsic_limin",pct_mpi(:,is_sic))
+  !         IF (read_continents .OR. itime == 1) THEN
+           IF (is_omp_master) CALL xios_recv_field("fter_limin",pct_mpi(:,is_ter))
+           IF (is_omp_master) CALL xios_recv_field("flic_limin",pct_mpi(:,is_lic))
+  !         ENDIF
+         ENDIF! type_ocean /= couple
+         
+         IF ( type_ocean /= 'couple') THEN                    
+             IF (is_omp_master) CALL xios_recv_field("sst_limin",sst_mpi)
+         ENDIF
+       
+         IF (.NOT. ok_veget) THEN
+           IF (is_omp_master) CALL xios_recv_field("alb_limin",alb_mpi)
+           IF (is_omp_master) CALL xios_recv_field("rug_limin",rug_mpi)
+         ENDIF
+
+       IF ( type_ocean /= 'couple') THEN
+          CALL Scatter_omp(sst_mpi,sst)
+          CALL Scatter_omp(pct_mpi(:,is_oce),pctsrf(:,is_oce))
+          CALL Scatter_omp(pct_mpi(:,is_sic),pctsrf(:,is_sic))
+!          IF (read_continents .OR. itime == 1) THEN
+             CALL Scatter_omp(pct_mpi(:,is_ter),pctsrf(:,is_ter))
+             CALL Scatter_omp(pct_mpi(:,is_lic),pctsrf(:,is_lic))
+!          END IF
+       END IF
+
+       IF (.NOT. ok_veget) THEN
+          CALL Scatter_omp(alb_mpi, albedo)
+          CALL Scatter_omp(rug_mpi, rugos)
+       END IF
+#endif
+
+ 
+     ELSE      ! grid_type==regular
+
 !$OMP MASTER  ! Only master thread
-       IF (is_mpi_root) THEN ! Only master processus
+       IF (is_mpi_root) THEN ! Only master processus!
 
           ierr = NF90_OPEN ('limit.nc', NF90_NOWRITE, nid)
@@ -371,4 +455,6 @@
        END IF
 
+      ENDIF ! Grid type
+
     ENDIF ! time to read
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/mo_simple_plumes.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/mo_simple_plumes.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/mo_simple_plumes.F90	(revision 3605)
@@ -78,4 +78,7 @@
     !
     INTEGER :: iret, ncid, DimID, VarID, xdmy
+    CHARACTER (len = 50)     :: modname = 'mo_simple_plumes.sp_setup'
+    CHARACTER (len = 80)     :: abort_message
+
     !
     ! ---------- 
@@ -84,5 +87,8 @@
        !    
        iret = nf90_open("MACv2.0-SP_v1.nc", NF90_NOWRITE, ncid)
-       IF (iret /= NF90_NOERR) STOP 'NetCDF File not opened'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF File not opened'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        !
        ! read dimensions and make sure file conforms to expected size
@@ -90,17 +96,29 @@
        iret = nf90_inq_dimid(ncid, "plume_number"  , DimId)
        iret = nf90_inquire_dimension(ncid, DimId, len = xdmy)
-       IF (xdmy /= nplumes) STOP 'NetCDF improperly dimensioned -- plume_number'
+       IF (xdmy /= nplumes) THEN
+          abort_message='NetCDF improperly dimensioned -- plume_number'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        !
        iret = nf90_inq_dimid(ncid, "plume_feature", DimId)
        iret = nf90_inquire_dimension(ncid, DimId, len = xdmy)
-       IF (xdmy /= nfeatures) STOP 'NetCDF improperly dimensioned -- plume_feature'
+       IF (xdmy /= nfeatures) THEN
+          abort_message='NetCDF improperly dimensioned -- plume_feature'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        !
        iret = nf90_inq_dimid(ncid, "year_fr"   , DimId)
        iret = nf90_inquire_dimension(ncid, DimID, len = xdmy)
-       IF (xdmy /= ntimes) STOP 'NetCDF improperly dimensioned -- year_fr'
+       IF (xdmy /= ntimes) THEN
+          abort_message='NetCDF improperly dimensioned -- year_fr'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        !
        iret = nf90_inq_dimid(ncid, "years"   , DimId)
        iret = nf90_inquire_dimension(ncid, DimID, len = xdmy)
-       IF (xdmy /= nyears) STOP 'NetCDF improperly dimensioned -- years'
+       IF (xdmy /= nyears) THEN
+          abort_message='NetCDF improperly dimensioned -- years'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        !
        ! read variables that define the simple plume climatology
@@ -108,54 +126,105 @@
        iret = nf90_inq_varid(ncid, "plume_lat", VarId)
        iret = nf90_get_var(ncid, VarID, plume_lat(:), start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading plume_lat'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading plume_lat'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "plume_lon", VarId)
        iret = nf90_get_var(ncid, VarID, plume_lon(:), start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading plume_lon'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading plume_lon'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "beta_a"   , VarId)
        iret = nf90_get_var(ncid, VarID, beta_a(:)   , start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading beta_a'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading beta_a'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "beta_b"   , VarId)
        iret = nf90_get_var(ncid, VarID, beta_b(:)   , start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading beta_b'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading beta_b'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "aod_spmx" , VarId)
        iret = nf90_get_var(ncid, VarID, aod_spmx(:)  , start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading aod_spmx'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading aod_spmx'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "aod_fmbg" , VarId)
        iret = nf90_get_var(ncid, VarID, aod_fmbg(:)  , start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading aod_fmbg'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading aod_fmbg'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "ssa550"   , VarId)
        iret = nf90_get_var(ncid, VarID, ssa550(:)  , start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading ssa550'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading ssa550'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "asy550"   , VarId)
        iret = nf90_get_var(ncid, VarID, asy550(:)  , start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading asy550'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading asy550'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "angstrom" , VarId)
        iret = nf90_get_var(ncid, VarID, angstrom(:), start=(/1/),count=(/nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading angstrom'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading angstrom'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        !
        iret = nf90_inq_varid(ncid, "sig_lat_W"     , VarId)
        iret = nf90_get_var(ncid, VarID, sig_lat_W(:,:)    , start=(/1,1/),count=(/nfeatures,nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading sig_lat_W'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading sig_lat_W'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "sig_lat_E"     , VarId)
        iret = nf90_get_var(ncid, VarID, sig_lat_E(:,:)    , start=(/1,1/),count=(/nfeatures,nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading sig_lat_E'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading sig_lat_E'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "sig_lon_E"     , VarId)
        iret = nf90_get_var(ncid, VarID, sig_lon_E(:,:)    , start=(/1,1/),count=(/nfeatures,nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading sig_lon_E'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading sig_lon_E'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "sig_lon_W"     , VarId)
        iret = nf90_get_var(ncid, VarID, sig_lon_W(:,:)    , start=(/1,1/),count=(/nfeatures,nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading sig_lon_W'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading sig_lon_W'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "theta"         , VarId)
        iret = nf90_get_var(ncid, VarID, theta(:,:)        , start=(/1,1/),count=(/nfeatures,nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading theta'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading theta'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "ftr_weight"    , VarId)
        iret = nf90_get_var(ncid, VarID, ftr_weight(:,:)   , start=(/1,1/),count=(/nfeatures,nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading plume_lat'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading plume_lat'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "year_weight"   , VarId)
        iret = nf90_get_var(ncid, VarID, year_weight(:,:)  , start=(/1,1/),count=(/nyears,nplumes   /))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading year_weight'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading year_weight'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        iret = nf90_inq_varid(ncid, "ann_cycle"     , VarId)
        iret = nf90_get_var(ncid, VarID, ann_cycle(:,:,:)  , start=(/1,1,1/),count=(/nfeatures,ntimes,nplumes/))
-       IF (iret /= NF90_NOERR) STOP 'NetCDF Error reading ann_cycle'
+       IF (iret /= NF90_NOERR) THEN
+          abort_message='NetCDF Error reading ann_cycle'
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
        !
        iret = nf90_close(ncid)
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/mod_synchro_omp.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/mod_synchro_omp.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/mod_synchro_omp.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 MODULE mod_synchro_omp
 
@@ -21,4 +24,6 @@
   IMPLICIT NONE
   LOGICAL :: out
+  CHARACTER (LEN=20) :: modname='synchro_omp'
+  CHARACTER (LEN=80) :: abort_message
   
     out=.FALSE.
@@ -46,5 +51,6 @@
 
     IF (exit_omp/=0) THEN
-      STOP 'synchro_omp'
+       abort_message='synchro_omp'
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/moy_undefSTD.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/moy_undefSTD.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/moy_undefSTD.F90	(revision 3605)
@@ -75,5 +75,5 @@
 
     IF (n==1 .AND. itap==itapm1 .OR. n>1 .AND. mod(itap,nint(freq_outnmc(n)/ & 
-        dtime))==0) THEN
+        phys_tstep))==0) THEN
 
       ! print*,'moy_undefSTD n itap itapm1',n,itap,itapm1
@@ -140,5 +140,5 @@
         END DO !i
       END DO !k
-    END IF !MOD(itap,NINT(freq_outNMC(n)/dtime)).EQ.0
+    END IF !MOD(itap,NINT(freq_outNMC(n)/phys_tstep)).EQ.0
 
   END DO !n
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/oasis.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/oasis.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/oasis.F90	(revision 3605)
@@ -104,7 +104,12 @@
 #ifdef CPP_XIOS
     USE wxios, ONLY : wxios_context_init 
+    USE xios  
 #endif
     USE print_control_mod, ONLY: lunout
-    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, grid_type, unstructured, regular_lonlat
+    USE geometry_mod, ONLY: ind_cell_glo                    
+    USE mod_phys_lmdz_mpi_data, ONLY: klon_mpi_para_nb
+    
+
 
 ! Local variables
@@ -113,5 +118,5 @@
     INTEGER                            :: ierror, il_commlocal
     INTEGER                            :: il_part_id
-    INTEGER, DIMENSION(3)              :: ig_paral
+    INTEGER, ALLOCATABLE               :: ig_paral(:)
     INTEGER, DIMENSION(2)              :: il_var_nodims
     INTEGER, DIMENSION(4)              :: il_var_actual_shape
@@ -136,5 +141,12 @@
 ! Define the model name
 !
-    clmodnam = 'LMDZ'       ! as in $NBMODEL in Cpl/Nam/namcouple.tmp
+    IF (grid_type==unstructured) THEN
+        clmodnam = 'icosa'                 ! as in $NBMODEL in Cpl/Nam/namcouple.tmp
+    ELSE IF (grid_type==regular_lonlat) THEN
+        clmodnam = 'LMDZ'                  ! as in $NBMODEL in Cpl/Nam/namcouple.tmp
+    ELSE
+	abort_message='Pb : type of grid unknown'
+	CALL abort_physic(modname,abort_message,1)
+    ENDIF
 
 
@@ -236,9 +248,30 @@
 ! Domain decomposition
 !************************************************************************************
-    ig_paral(1) = 1                            ! apple partition for //
-    ig_paral(2) = (jj_begin-1)*nbp_lon+ii_begin-1  ! offset
-    ig_paral(3) = (jj_end*nbp_lon+ii_end) - (jj_begin*nbp_lon+ii_begin) + 1
-
-    IF (mpi_rank==mpi_size-1) ig_paral(3)=ig_paral(3)+nbp_lon-1
+    IF (grid_type==unstructured) THEN
+
+      ALLOCATE( ig_paral(klon_mpi_para_nb(mpi_rank) + 2) ) 
+
+      ig_paral(1) = 4                                      ! points partition for //
+      ig_paral(2) = klon_mpi_para_nb(mpi_rank)             ! nb of local cells
+
+      DO jf=1, klon_mpi_para_nb(mpi_rank)
+        ig_paral(2+jf) = ind_cell_glo(jf)
+      ENDDO
+
+    ELSE IF (grid_type==regular_lonlat) THEN
+
+      ALLOCATE( ig_paral(3) )
+
+      ig_paral(1) = 1                            ! apple partition for //
+      ig_paral(2) = (jj_begin-1)*nbp_lon+ii_begin-1  ! offset
+      ig_paral(3) = (jj_end*nbp_lon+ii_end) - (jj_begin*nbp_lon+ii_begin) + 1
+
+      IF (mpi_rank==mpi_size-1) ig_paral(3)=ig_paral(3)+nbp_lon-1
+    ELSE
+      abort_message='Pb : type of grid unknown'
+      CALL abort_physic(modname,abort_message,1)
+    ENDIF
+
+
     WRITE(lunout,*) mpi_rank,'ig_paral--->',ig_paral(2),ig_paral(3)
     
@@ -253,11 +286,11 @@
     ENDIF
 
-    il_var_nodims(1) = 2
-    il_var_nodims(2) = 1
-
-    il_var_actual_shape(1) = 1
-    il_var_actual_shape(2) = nbp_lon
-    il_var_actual_shape(3) = 1
-    il_var_actual_shape(4) = nbp_lat
+    il_var_nodims(1) = 2                        ! rank of field array (1d or 2d)
+    il_var_nodims(2) = 1                        ! always 1 in current oasis version" doc oasis3mct p18
+
+    il_var_actual_shape(1) = 1                  ! min of 1st dimension (always 1)
+    il_var_actual_shape(2) = nbp_lon            ! max of 1st dimension
+    il_var_actual_shape(3) = 1                  ! min of 2nd dimension (always 1)
+    il_var_actual_shape(4) = nbp_lat            ! max of 2nd dimension
    
     il_var_type = PRISM_Real
@@ -302,4 +335,7 @@
 ! End definition
 !************************************************************************************
+#ifdef CPP_XIOS
+    CALL xios_oasis_enddef()
+#endif
     CALL prism_enddef_proto(ierror)
     IF (ierror .NE. PRISM_Ok) THEN
@@ -311,5 +347,5 @@
 
 #ifdef CPP_XIOS
-    CALL wxios_context_init()
+!    CALL wxios_context_init()
 #endif
 
